#
# Source ici : http://www.lacim.uqam.ca/~blondin/posts/fr/fractales.html
#

# recursivite_avec_turtle.py

from turtle import *

def reset(x, y):
    r"""
    Moves the turtle to position (x, y) without
    drawing anything and sets the angle to 90.
    """
    penup()
    setpos(x, y)
    pendown()
    setheading(90)

def f(height, resolution):
    r"""
    Draws a plant of given height and given
    resolution.

    The highest the resolution is, the more
    detailed the plant is drawn. For instance,
    if the resolution is 1, then the basic
    plant is drawn. If the resolution is 3,
    then the plant presents many details.
    """
    if resolution == 0:
        forward(height)
    else:
        # Drawing the bottom
        f(height / 3.0, resolution - 1)

        # Drawing the right branch
        right(30)
        f(height / 3.0, resolution - 1)
        penup()
        backward(height / 3.0)
        pendown()

        # Drawing the middle
        left(30)
        f(height / 3.0, resolution - 1)

        # Drawing the left branch
        left(30)
        f(height / 3.0, resolution - 1)
        penup()
        backward(height / 3.0)
        pendown()

        # Drawing the top part
        right(30)
        f(height / 3.0, resolution - 1)

# Drawing parameters
height = 300                                    # height of plants
ss     = ['slowest', 'slow', 'fast', 'fastest'] # speeds
xs     = [-240, -80, 80, 240]                   # x positions of plants
y      = -100                                   # y position of plants

# Draw plants
for i in range(4):
    speed(ss[i])
    reset(xs[i], y)
    f(height, i + 1)

exitonclick()